program Expand_weight
  !  cause a weight to expand by one sample in each direction
  !
  use sep

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3
  integer, dimension(:,:,:), allocatable    :: knownvec
  real,    dimension (:,:,:),   allocatable :: inwt,outwt

  call sep_init ()
  call from_history (n1,n2,n3,esize=4)
  call to_history ("esize",4)

  write(0,*) n1,n2,n3


  allocate (outwt(n1,n2,n3),inwt(n1,n2,n3))          


  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", inwt,4*n1*n2*n3)

  outwt=inwt 

  !take each point in the cube
  do i3=1,n3
     do i2=1,n2
        do i1=1,n1      
           !    if (inwt(i1,i2,i3)==1) then  ! if already zero then get next sample
!!$           if ((inwt(int(max(i1-1,1)),i2,i3)==0).or.(inwt(int(min(i1+1,n1)),i2,i3)==0)) then
!!$              outwt(i1,i2,i3)=0.
!!$           end if
!!$           if ((inwt(i1,int(max(i2-1,1)),i3)==0).or.(inwt(i1,int(min(i2+1,n2)),i3)==0)) then
!!$              outwt(i1,i2,i3)=0.
!!$              !           else if ((inwt(i1,i2,int(max(i3-1,1)))==0).or.(inwt(i1,i2,int(min(i3+1,n3)))==0)) then
!!$              !              outwt(i1,i2,i3)=0
!!$           end if
!!$     

!!$           if ((inwt(i1,int(max(i2-1,1)),i3)==0).or.(inwt(i1,int(min(i2+1,n2)),i3)==0)) then
!!$              outwt(i1,i2,i3)=0.
!!$              !           else if ((inwt(i1,i2,int(max(i3-1,1)))==0).or.(inwt(i1,i2,int(min(i3+1,n3)))==0)) then
!!$              !              outwt(i1,i2,i3)=0
!!$           end if
!!$       if ((inwt(int(max(i1-1,1)),i2,i3)==0).or.(inwt(int(min(i1+1,n1)),i2,i3)==0)) then
!!$              outwt(i1,i2,i3)=0.
!!$           end if

     if ((inwt(i1,i2,i3)<0.2))then
outwt(i1,(max(i2-1,1)),i3)=0.
outwt(i1,(min(i2+1,n2)),i3)=0.
outwt(i1,i2,(max(i3-1,1)))=0.
outwt(i1,i2,(min(i3+1,n3)))=0.
outwt((max(i1-1,1)),i2,i3)=0.
outwt((min(i1+1,n1)),i2,i3)=0.
end if
      !          if      (inwt(int(min(i1+1,n1)),i2,i3)==0) then
           !             outwt(i1,i2,i3)=0
           !          else if (inwt(i1,int(min(i2+1,n2)),i3)==0) then
           !             outwt(i1,i2,i3)=0
           !     else if ((inwt(i1,i2,int(max(i3-1,1)))==0).or.(inwt(i1,i2,int(min(i3+1,n3)))==0)) then
           !       outwt(i1,i2,i3)=0
           !         end if


           !     end if
        end do
     end do
  end do

  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call sep_write (outwt) 

!!$  call to_history("n1",n1,"outwt"); call to_history("n2",n2,"outwt")
!!$  call to_history("n3",n3,"outwt")
!!$  call to_history("d1",1.0,"outwt"); call to_history("d2",1.0,"outwt")
!!$  call to_history("d3",1.0,"outwt")
!!$  call to_history("o1",0.,"outwt"); call to_history("o2",0.,"outwt")
!!$  call to_history("o3",0.,"outwt")
!!$  call to_history("esize",4,"outwt")
!!$  call sep_write(outwt,"outwt")	
!!$




  deallocate (inwt,outwt)
  call sep_close()
  call exit (0)
end program Expand_weight














