program Dipintegrator_3D
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use dipinteg_3D
  use igrad3_period
  use change_jl

  implicit none
  integer 	                          :: n1, n2, n3, iter
  real                                    :: q
  complex, dimension (:,:,:),   allocatable :: data_in
  real,    dimension (:),     allocatable :: hh
  real,    dimension (:,:,:),   allocatable :: data_amp,data_phz,data_real,data_imag,px,py,pz,px_mirr,py_mirr,pz_mirr,hh_3D,hh_3D_trun
  call sep_init ()
  call from_history (n1,n2,n3, esize = 8)
 ! n1=64
 ! n2=64
 ! n3=64

  allocate (data_in (n1,n2,n3))                                   ! read data
  call sep_read (data_in) ! ; data_in = data_in / maxval (cabs (data_in)) ! normalize

  allocate (px(n1,n2,n3),py(n1,n2,n3),pz(n1,n2,n3))
  !  allocate (px_mirr(n1,n2*2,n3*2),py_mirr(n1,n2*2,n3*2),pz_mirr(n1,n2*2,n3*2))

  px=real(data_in)  ! x direction dip
  py=aimag(data_in)  ! y direction dip
 ! px=1.
 ! py=1.
  pz=1. ! set to 1's

 
!allocate(test3D(2,2,1),test1D(2*2*1),test2D(2,2),source(6),destination(2,3))
!test3D=1.
!test1D=1.
!allocate(new_shape(3))
!new_shape(2)=(/ size(test3D),1,1/)
!new_shape(1)=1
!test2D=reshape(test1D,(/ 2,2/))
!test1D=reshape(test2D,(/4/))

!test3D=reshape(test1D,(/ 2,2,1/))
!test1D=reshape(test3D,(/4/))

!deallocate(test3D,test1D)
!allocate(test3D(2,3,2),test1D(2*3*2))
!test3D=1.
!write(0,*) size(test1D),size(test3D),'1Dshape',shape(test1D),'3Dshape',shape(test3D)
!test3D=reshape(test1D,(/ 2,2,2/))
!write(0,*) test3D
!test1D=reshape(test3D,(/8/))

!write(0,*) 'test1D', test1D
!write(0,*) size(test1D),size(test3D),'1Dshape',shape(test1D),'3Dshape',shape(test3D)

!write(0,*) 'here here here'
 !       source=1.
!	destination=reshape(source,(/2,3/))
!        source=reshape(destination,(/6/))
!write(0,*) destination
!write(0,*) source
!test1D=reshape(test3D,(1000))
!i1=reshape((/1 ,1 ,1 /),(/2,1/)
!stop


  deallocate(data_in)
  allocate (px_mirr(n1,n2*2,n3*2),py_mirr(n1,n2*2,n3*2),pz_mirr(n1,n2*2,n3*2))
  !%%%%%%%%%%%%% make mirror
  px_mirr(1:n1,1:n2,1:n3)       = px(:,:,:)
  px_mirr(1:n1,1:n2,n3+1:2*n3)  = px(1:n1,1:n2,n3:1:-1);
  px_mirr(1:n1,n2+1:n2*2,1:2*n3)= -1.*px_mirr(1:n1,n2:1:-1,1:2*n3);

  py_mirr(1:n1,1:n2,1:n3)       = py(:,:,:);
  py_mirr(1:n1,n2+1:2*n2,1:n3)  = py(1:n1,n2:1:-1,1:n3);
  py_mirr(1:n1,1:2*n2,n3+1:n3*2)= -1.*py_mirr(1:n1,1:2*n2,n3:1:-1);

  pz_mirr=1.
 pz_mirr(n1,:,:)=-(n1-1)

pz=1.
!pz(n1,:,:)=-(n1-1)
!px(:,n2,:)=-(n2-1)
!py(:,:,n3)=-(n3-1)
  deallocate(px,py,pz)
  allocate(hh(n1*n2*n3*4))

  write(0,*) 'size',size(px), size(py), size(pz)
!        call auxputch('n1','d',n1,'junk.H')
!	call auxputch('n2','d',2*n2,'junk.H')
!	call auxputch('n3','d',2*n3,'junk.H')
!	call auxputch('n4','d',1,'junk.H')
!	call srite("junk.H",px_mirr,size(px_mirr)*4)



  write(0,*) 'n1,n2,n3',n1,n2,n3
  !   call Park_unwraper_analytic (data_in, hh)           

  call dipintegrate_3D (px_mirr,py_mirr,pz_mirr, hh)
write(0,*) 'before dipintegrate'
 ! call dipintegrate_3D (px,py,pz, hh)
write(0,*) 'passed dipintegrate'
  allocate(hh_3D(n1,2*n2,2*n3))
 ! hh_3D= reshape(hh,(/n1,2*n2,2*n3/))
call change_sub_to_3D(hh, hh_3D ,n1,2*n2,2*n3)
 ! allocate(hh_3D(n1,n2,n3))
 ! hh_3D= reshape(hh,(/n1,n2,n3/))


!	call auxputch('n1','d',n1,'junk.H')
!	call auxputch('n2','d',2*n2,'junk.H')
!	call auxputch('n3','d',2*n3,'junk.H')
!	call auxputch('n4','d',1,'junk.H')
!	call srite("junk.H",hh,size(hh)*4)


  deallocate(hh)
  allocate(hh_3D_trun(n1,n2,n3))
  hh_3D_trun=hh_3D(1:n1,1:n2,1:n3)
  deallocate(hh_3D)

  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)

  call sep_write (hh_3D_trun) 



  deallocate (hh_3D_trun)
  call sep_close()
  call exit (0)
end program Dipintegrator_3D











