program Precon_3D
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use dipinteg_3D
  use dipinteg_precond
  use igrad3_period 
!  use change_jl
  use fault_weight
  use igrad2
  use igrad3_epst
  use chain_mod
  use prec_oper
 ! use cgstep_jesse_mod
use cgstep_wrt_mod 
 use polydiv
  use lapfac
  use lapfac3
  use solver_prc_mod
  use solver_smp_jesse_3D_mod

  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice,k,k_max,niter
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,stat1,stat2 
  integer                                    ::method,na
  real                                       :: q,eps_t,eps_h,pi_var,beta,alpha,epsi
  double precision     :: alpha_new,beta_new
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:),   allocatable    ::ztrans
  real,    dimension (:),     allocatable    :: cos_wt,res_out,err_out
  real,    dimension(:),pointer              ::rt,hh,Fop,ww,tmp1,tmp2,rt_adj,tmp3,rt_wt,rd_jes
  real,    dimension (:,:),   allocatable  ::hh_2D,tau,r,z,p
  real,    dimension (:),   allocatable      ::s,BigR,BigS,g,BigG,init_m
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,outwt
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3d
  real,    dimension  (2)   :: dot1,dot2
  type(filter)      :: aa
  logical ::forget
  call sep_init ()
  call from_history (n1,n2,n3, esize = 8)
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("mirror",mirror,1)
  call from_param("bounds",bounds,1)
  call from_param("slice",slice,0)

  call from_param("method",method,1)
  call from_param("niter",niter,10)

  allocate(data_in(n1,n2,n3),px(n1,n2,n3),py(n1,n2,n3))






  ! CREATE PI VARIABLE
  pi_var=acos(-1.)





  allocate(hh(n1*n2*n3))
!!$  allocate(hh_2D(n1,n2))


  !  allocate( ztrans3d(n1,2*n2,2*n3))
  allocate(outwt(n1,n2,n3),ww((n1)*(n2)*(n3)*3))
  ! call z_trans(2*n1,2*n2,ztrans)
  call sreed("wt", outwt,4*n1*n2*n3)
  ww=0.
  ww(1:(n1)*(n2)*(n3))=reshape(outwt,(/(n1)*(n2)*(n3)/))
  ww((n1)*(n2)*(n3)+1:(n1)*(n2)*(n3)*2)=reshape(outwt,(/(n1)*(n2)*(n3)/))
   ww((n1)*(n2)*(n3)*2+1:(n1)*(n2)*(n3)*3)=reshape(outwt,(/(n1)*(n2)*(n3)/))
  ! deallocate(ww_3D)

  !do it=1,n3

  allocate( rt( n1*n2*n3*3))

  call sep_read (data_in)

  ! BREAK INPUT CUBE INTO X DIP DIRECTION AND Y DIP DIRECTIONS
  px=real(data_in)  ! x direction dip

  py=aimag(data_in)  ! y direction dip
  !write(0,*) maxval(px),minval(px),sum(px)/size(px)
  rt=0.
  hh=0.

  rt=0.

  rt(n1*n2*n3+1:2*n1*n2*n3)=reshape(px,(/size(px)/))
  rt(2*n1*n2*n3+1:3*n1*n2*n3)=reshape(py,(/size(py)/))


  call fault_w_init(ww)
  call igrad2_init(n1,n2)
  write(0,*) 'n1,n2,n3',n1,n2,n3
  call igrad3_epst_init(n1,n2,n3,eps_t)
  call dot_test (igrad3_epst_lop,n1*n2*n3,n1*n2*n3*3,dot1,dot2)

  write(0,*) 'initiallized igrad3_epst'
  !method=1
  select case(method)
  case(0)

     k_max=10
     allocate(tau(n1*n2*n3,k_max),r(n1*n2,k_max),z(n1*n2,k_max),p(n1*n2,k_max))
     allocate(Fop(n1*n2),tmp2(n1*n2*2),tmp1(n1*n2*2),tmp3(n1*n2))
     allocate(s(n1*n2),BigS(n1*n2),g(n1*n2),BigG(n1*n2),BigR(n1*n2))
     z=0.

     k=1 
     tau=0. 



     allocate( rt_adj(n1*n2*n3))


     ! APPLY DIVERGENCE
     !   stat1=igrad3_period_eps_lop(.true.,.false.,rt_adj , rt) 
     stat1=igrad2_lop(.true.,.false.,rt_adj , rt) 
     r(:,1)=rt_adj
     call prec_oper_init(n1,n2,ww)
     !   call dot_test (prec_oper_ex,n1*n2,n1*n2,dot1,dot2)
     do

        if (k/=1) then
!!$        allocate( rt( n1*n2*2))
           rt_adj=r(:,k)
        end if

        call dipintegrate_precond (rt_adj,z(:,k),eps_t,eps_h,1,n1,n2,ztrans)   
!!$tmp3=z(:,k)
!!$exit
        ! hh_2D=reshape(hh,(/n1,n2/))
        !   r(k)=rt
        k=k+1
        write(0,*) 'k',k
        if (k==2) then
           p(:,k)=z(:,k-1)

!!$        stat2 = igrad2_lop (.false., .false., p(:,k), tmp1)
!!$        stat1 = fault_w_oper (.false., .false., tmp1, tmp2)
!!$        stat2 = igrad2_lop (.true., .false., Fop, tmp2)

!!$           stat2 = igrad2_lop (.false., .false., p(:,k),Fop)
!!$
!!$           alpha=sum(dprod(r(:,k-1),z(:,k-1)))/sum(dprod(p(:,k),Fop))
!!$           tau(:,k)=tau(:,k-1)+alpha*p(:,k)
!!$           write(0,*) 'alpha',alpha
!!$           r(:,k)=r(:,k-1)-alpha*Fop
!!$           write(0,*) 'residual',sum(r(:,k)),'alpha',alpha,sum(r(:,k-1))
!!$           !   if (k>=k_max.or.abs(sum(r(:,k)))<.08*abs(sum(r(:,1)))) exit
!!$
!!$           s=alpha*p(:,k)

        else

           beta=sum(dprod(r(:,k-1),z(:,k-1)))/sum(dprod(r(:,k-2),z(:,k-2)))
           p(:,k)=z(:,k-1)+beta*p(:,k-1)
           write(0,*) 'beta',beta

!!$           BigR=r(:,k)
!!$           stat1=prec_oper_ex(.false.,.false.,s,BigS)
!!$           stat1=prec_oper_ex(.true.,.false.,g,BigR)
!!$           stat1=prec_oper_ex(.false.,.false.,g,BigG)
!!$
!!$           forget=.false.
!!$           stat1 = cgstep_jesse (forget, alpha_new,beta_new, g, BigR, BigG,BigS)
!!$           !   call cgstep_jesse_close
!!$           s  = alpha_new *  g + beta_new *  s            ! update solution step
!!$           BigS = alpha_new * BigG + beta_new * BigS            ! update residual step
!!$           tau(:,k)  =  tau(:,k-1) +  s                          ! update solution
!!$           r(:,k) = r(:,k-1) + BigS                      



           write(0,*) 'residual',sum(r(:,k)),alpha_new,beta_new
        end if

!!$      !  call chain (fault_w_oper,igrad2_lop,.false.,.false.,p(:,k),Fop,tmp1)
!!$
!!$!stat1=prec_oper_ex(.false.,.false.,p(:,k),tmp1)   





!!$        stat2 = igrad2_lop (.false., .false., p(:,k), tmp1)
!!$        stat1 = fault_w_oper (.false., .false., tmp1, tmp2)
!!$        stat2 = igrad2_lop (.true., .false., Fop, tmp2)
        stat1=prec_oper_ex(.false.,.false.,p(:,k),Fop)
        write(0,*) 'a',sum(dprod(r(:,k-1),z(:,k-1))),sum(dprod(p(:,k),Fop))
        alpha=sum(dprod(r(:,k-1),z(:,k-1)))/sum(dprod(p(:,k),Fop))
        tau(:,k)=tau(:,k-1)+alpha*p(:,k)
        write(0,*) 'alpha',alpha
        r(:,k)=r(:,k-1)-alpha*Fop
        write(0,*) 'residual',sum(r(:,k))

        if (k>=k_max.or.abs(sum(r(:,k)))<.0008*abs(sum(r(:,1)))) exit

     end do
     !tau(:,k)=z(:,k-1)
     ! tau=-1.*tau
  case(1) ! congacates without preconditioning  G'Gt=G'p

     k_max=1
     allocate(tau(n1*n2*n3,k_max),res_out(niter))
     z=0.

     k=1 
     tau=0. 

     if (exist_file("initial_model")) then
        allocate(init_m(n1*n2*n3))
        call sreed("initial_model",init_m,n1*n2*n3*4)
        call solver_smp_jesse3D(tau(:,k), rt,igrad3_epst_lop,cgstep_wrt,niter,eps_t,verb=.true.,Wop=fault_w_oper,n1_in=n1,n2_in=n2,n3_in=n3,m0=init_m,err=res_out)
     else
        call solver_smp_jesse3D(tau(:,k), rt,igrad3_epst_lop,cgstep_wrt,niter,eps_t,verb=.true.,Wop=fault_w_oper,n1_in=n1,n2_in=n2,n3_in=n3,err=res_out)
        call cgstep_wrt_close ()
     end if

  case(2) 
     k=1
     allocate(tau(n1*n2,k),res_out(niter))
     call solver_smp(tau(:,k), rt,igrad2_lop,cgstep_wrt,40,verb=.true.,Wop=fault_w_oper)
     call cgstep_wrt_close ()
  case(3)
     k=1
     na=20
     epsi=.1
     !  eps_t=0.
     !   aa = lapfac2(epsi,n1,na) ! REMOVED
     write(0,*) 'about to factor laplacian' 
     aa = lapfac3d(epsi,n1,n2,na,eps_t) ! REMOVED
     write(0,*) 'factored laplacian' 
     call polydiv_init(n1*n2*n3,aa) ! REMOVED

     allocate(tau(n1*n2*n3,k),res_out(niter))
     write(0,*) 'beginning solver'
     call solver_prc(tau(:,k), rt,igrad3_epst_lop,polydiv_lop,cgstep_wrt,n1*n2*n3,niter,0.,Wop=fault_w_oper,verb=.true.,err=res_out)
     ! call solver_smp(tau(:,k), rt,igrad3_epst_lop,cgstep,30,Wop=fault_w_oper,verb=.true.)
     call cgstep_wrt_close ()
  case(4)  ! 

     k=1
     na=10
     epsi=.1
     aa = lapfac2(epsi,n1,na) ! REMOVED
     call polydiv_init(n1*n2,aa) ! REMOVED

     allocate(tau(n1*n2,k),tmp3(n1*n2), rt_adj(n1*n2*n3),rt_wt(size(rt)))
     stat1=fault_w_oper(.false.,.false.,rt , rt_wt)
     stat1=igrad2_lop(.true.,.false.,rt_adj , rt)
     stat1=polydiv_lop(.false.,.false.,rt_adj,tmp3)
     stat1=polydiv_lop(.true.,.false.,tau(:,k),tmp3)
  case(5) 
     k=1
     na=20
     epsi=.1
     !  eps_t=0.
     !   aa = lapfac2(epsi,n1,na) ! REMOVED
     write(0,*) 'about to factor laplacian' 
     aa = lapfac3d(epsi,n1,n2,na,eps_t) ! REMOVED
     write(0,*) 'factored laplacian' 
     call polydiv_init(n1*n2*n3,aa) ! REMOVED

     allocate(tau(n1*n2*n3,k))
     write(0,*) 'beginning solver'
     call solver_prc(tau(:,k), rt,igrad2_lop,polydiv_lop,cgstep_wrt,n1*n2*n3,niter,0.,Wop=fault_w_oper,verb=.true.)
     ! call solver_smp(tau(:,k), rt,igrad3_epst_lop,cgstep,30,Wop=fault_w_oper,verb=.true.)
     call cgstep_wrt_close ()

  end select

  allocate(tau_3d(n1,n2,n3))
  tau_3d=reshape(tau(:,k),(/n1,n2,n3/))
!!$  do it=1, 256
!!$     tau_3d(it,:,:)=reshape(tau(:,k),(/n1,n2/))
!!$     ! tau_3d(it,:,:)=reshape(z(:,k-1),(/n1,n2/))
!!$  end do


  call sep_write (tau_3d) 
  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)
! calculate W(Grad m - p) for res_out(1) 
allocate(rd_jes(size(rt)),err_out(niter+1))
!call chain0(Wop,igrad3_epst_lop,F,F,g,gd,tm,td)
 stat1=fault_w_oper(.false.,.false.,-rt,rd_jes)
 err_out(  1) = dot_product(rd_jes,rd_jes)
err_out(2:niter+1)=res_out
 call sep_write(err_out,"res_out")	
 call to_history("n1",niter+1,"res_out")
 call sep_close()
  call exit (0)


end program Precon_3D











